{$M 64000,0,655360}

Type int=integer;

var l,ll:array[1..2] of longint;
    w:word;
    i:integer;

Var Endian_w:array[0..10239] of word;

Procedure Do16(var S);
Var w:word;
Begin
  move(S,w,2);
  w:=swap(w);
  Move(w,S,2);
End;

Procedure Do16s(var S; Cnt:Integer);
Var i:integer;
Begin
  Move(S,Endian_w,2*cnt);
  For i:=0 to cnt-1 do Endian_w[i]:=swap(Endian_w[i]);
  Move(Endian_w,S,2*cnt);
End;

Procedure Xchg(var a,b:word);
Var c:word;
Begin
  c:=a;
  a:=b;
  b:=c;
End;

Procedure Do32(var L);
Var ww:array[0..1] of word;
Begin
  Move(L,ww,4);
  ww[0]:=swap(ww[0]);
  ww[1]:=swap(ww[1]);
  xchg(ww[0],ww[1]);
  Move(ww,L,4);
End;

Procedure Do32s(var L; Cnt:integer);
Begin
  Move(L,Endian_W,4*cnt);

  For i:=0 to 2*cnt-1 do Endian_W[i]:=swap(Endian_W[i]);
  For i:=0 to cnt-1 do Xchg(Endian_W[2*i],Endian_W[2*i+1]);

  Move(Endian_W,L,4*cnt);
End;


begin
  writeln('Byte......... ',sizeof(byte),' byte(s)');
  writeln('ShortInt..... ',sizeof(shortint),' byte(s)');
  writeln('Word......... ',sizeof(word),' bytes');
  writeln('Integer...... ',sizeof(integer),' bytes');
  writeln('Longint...... ',sizeof(longint),' bytes');
{  writeln('Cardinal..... ',sizeof(cardinal),' bytes');}

  i:=2154;
  l[1]:=$12345678;
  l[2]:=$9ABCDEF0;

  ll:=l;
  Do32s(l,1);

end.