program TrueType_in_Text__to__MetaFont__Converter;

var n,i:integer;
      h:real;

procedure Header;
begin
 writeln('mode_setup;');
 writeln;
 writeln('u#:=1pt#;');
 writeln('define_pixels(u);');
 writeln('currenttransform:=currenttransform scaled u;');
 writeln;
 writeln('primarydef v picxor w =');
 writeln(' begingroup');
 writeln('  picture q; q=v+w; cull q keeping (1,1); q');
 writeln(' endgroup');
 writeln('enddef;');
 writeln;
 writeln('picture pom;');
 writeln('def neg expr p = pom:=nullpicture; addto pom contour p.t_;');
 writeln('                 currentpicture:=currentpicture picxor pom; enddef;');
 writeln('def c(expr a,b,c,d) = .. controls (a,b) and (c,d) .. enddef;');
 writeln;
end;

function P(x,y:real):string;
var s,q:string;

begin
 s:='(';
 str(x:0:2,q);
 s:=s+q+',';
 str(y:0:2,q);
 s:=s+q+')';
 P:=s;
end;

procedure RobObrys(m:real);
var n,i:integer;
    ax,ay,bx,by,cx,cy,dx,dy:real;

begin
 read(n);
 write(' neg ');
 for i:=1 to n do
  begin
   read(ax,ay,bx,by,cx,cy,dx,dy);
   ax:=ax/100;ay:=ay/100+m;
   bx:=bx/100;by:=by/100+m;
   cx:=cx/100;cy:=cy/100+m;
   dx:=dx/100;dy:=dy/100+m;
   writeln(P(ax,ay),'c(',bx:0:2,',',by:0:2,',',cx:0:2,',',cy:0:2,')');
  end;
 writeln(P(dx,dy),'..cycle;');
end;

procedure Robznak;
var ch:byte;
    s,v,vs:real;
    n,i:integer;

begin
 read(ch,s,v,vs,n);
 s:=s/100;v:=v/100;vs:=vs/100;
 if h<v then h:=v;
 writeln('beginchar(',ch,',',s:0:4,'u#,',v:0:4,'u#,',vs:0:4,'u#);');
 for i:=1 to n do
  RobObrys(vs);
 writeln('endchar;');
 writeln;
end;

begin
 if paramcount<1 then
  begin
   writeln('Nezadal si vstup !');
   writeln('Zadaj meno vstupneho suboru bez koncovky !');
   halt;
  end;
 {$I-}
 assign(input,paramstr(1)+'.exp');
 reset(input);
 {$I+}
 if IOResult<>0 then
  begin
   writeln('Zle si zadal vstup !');
   halt;
  end;
 assign(output,paramstr(1)+'.mf');
 rewrite(output);
 header;
 h:=0;
 read(n);
 for i:=1 to n do
  RobZnak;
 writeln('font_size ',h:0:4,'u#;');
 writeln('font_normal_space ',h/1.5:0:4,'u#;');
 writeln('end;');
end.