Unit TTDisp;

interface

uses TTTypes;

procedure SetGraphScreen;

procedure RestoreScreen;

procedure Display( var Buff; Line, Col : Int );

procedure Clear( Line, Col : Int );

var
  Vio : PByteArray;

implementation

  procedure SetGraphScreen;
  begin
    asm
      mov ax,$0012
      int $10
    end;
    Vio := PByteArray( @Mem[$A000:0] );
  end;

  procedure RestoreScreen; assembler;
  asm
    mov ax,$0003
    int $10
  end;

  procedure Display; assembler;
  asm
    push ds
    push bp

    mov ax,$A000
    mov es,ax

    lds si,[Buff]

    cld

    mov cx,80
    mov bx,[col]
    mov ax,[line]
    dec ax
    mul cx
    mov di,ax
    mov dx,[line]
    mov bp,bx
    add bx,80
   @1:
    mov cx,bp
    rep movsb
    sub di,bx
    dec dx
    jnz @1

    pop bp
    pop ds
  end;

  procedure Clear; assembler;
  asm
    push ds
    push bp

    mov ax,$A000
    mov es,ax

    cld

    mov cx,80
    mov bx,[col]
    mov ax,[line]
    dec ax
    mul cx
    mov di,ax
    mov dx,[line]
    mov bp,bx
    add bx,80
    xor al,al
   @1:
    mov cx,bp
    rep stosb
    sub di,bx
    dec dx
    jnz @1

    pop bp
    pop ds
  end;


begin
end.

