Unit IO_check;

Interface

Const o_READ    = $0101;
      o_REWRITE = $0102;
      o_APPEND  = $0103;

      IO_error : string = '';


Procedure CorrectExit;   { MUST BE CALLED AT THE END OF MAIN PROGRAM !!!!!! }
Function Exist(s:string):boolean;
Procedure OpenText(var f:text; name:string; opn:word);

Function x2i(s:string):word;
Function s2i(s:string):word;


Implementation
Uses crt;
Const HexStr : string = '0123456789ABCDEF';

Var OldExitProc:pointer;


Function x2i(s:string):word;
Var hextab:string;
    q,i,n,v,a:word;
Begin
     n:=1;
     v:=0;
     hextab:='0123456789ABCDEF';
     x2i:=0;

     q:=length(s);
     If pos(' ',s)<>0 then q:=pos(' ',s)-1;

     For i:=q downto 1 do
     Begin
          a:=Pos(upcase(s[i]),hextab);
          If a=0 then exit;

          dec(a);
          v:=v+n*a;
          n:=16*n;
     End;

     x2i:=v;
End;

Function s2i(s:string):word;
Var code:integer;
    v,q:word;
Begin
     q:=length(s);
     If pos(' ',s)<>0 then q:=pos(' ',s)-1;

     Val(copy(s,1,q),v,code);
     s2i:=v;
End;


Function Exist(s:string):boolean;
Var f:file;
Begin
     assign(f,s);
     {$I-}
     reset(f,1);
     {$I+}
     If IOresult=0 then Exist:=true else Exist:=false;
End;

Procedure OpenText(var f:text; name:string; opn:word);
Begin
     assign(f,name);

     Case opn of
          o_READ    : Begin
                           IO_error:='\FFile \E"'+name+'"\f cannot be opened for reading.';
                           reset(f);
                      End;

          o_REWRITE : Begin
                           IO_error:='\fFile \e"'+name+'"\f cannot be opened for writting.';
                           rewrite(f);
                      End;

          o_APPEND  : Begin
                           IO_error:='\fFile \e"'+name+'"\f cannot be opened for appending.';
                           append(f);
                      End;
     End;

     IO_error:='';
End;



Procedure COLORwrite(s:string);
Var attr,i,j:byte;
Begin
     j:=1;
     attr:=textattr;

     For i:=1 to length(s) do
     Begin
          If s[j]='\' then
          Begin
               If ((j+1<=length(s)) and (upcase(s[j+1]) in ['0'..'9','A'..'F'])) then
               Begin
                    inc(j,2);
                    textcolor(Pos(upcase(s[j-1]),hexstr)-1);
                    inc(i);
               End
               Else
               Begin
                    write(s[j]);
                    inc(j);
               End;
          End
          Else
          Begin
               write(s[j]);
               inc(j);
          End;
     End;

     textattr:=attr;
End;


Procedure COLORwriteln(s:string);
Var attr,i,j:byte;
Begin
     j:=1;
     attr:=textattr;

     For i:=1 to length(s) do
     Begin
          If s[j]='\' then
          Begin
               If ((j+1<=length(s)) and (upcase(s[j+1]) in ['0'..'9','A'..'F'])) then
               Begin
                    inc(j,2);
                    textcolor(Pos(upcase(s[j-1]),hexstr)-1);
                    inc(i);
               End
               Else
               Begin
                    write(s[j]);
                    inc(j);
               End;
          End
          Else
          Begin
               write(s[j]);
               inc(j);
          End;
     End;

     textattr:=attr;
     writeln;
End;


Function i2s(i:word):string;
Var s1:string;
Begin
     Str(i,s1);
     i2s:=s1;
End;

Procedure RunTime; far;
Begin
     COLORwrite('\CERROR: ');

     If IO_error<>'' then
     Begin
          COLORwriteln(IO_error);
          COLORwriteln('\7(runtime error '+i2s(exitcode)+')');
          exitcode:=0;
          erroraddr:=nil;
     End;

     ExitProc:=OldExitProc;
End;


Procedure CorrectExit;
Begin
     ExitProc:=OldExitProc;
End;


Begin
     OldExitProc:=ExitProc;
     ExitProc:=Addr(RunTime);
End.