Program Process_CMAP_table_2;
Var f1,f2:file;

    cmapdir : record
                    version,count:word;
              end;

    CmapDirInfo : record
                        PlatformID,EncodingID:word;
                        Offset:longint;
                  end;

    Cmap4 : record
                  format,length,version:word;
                  segCountX2,
                  searchRange,
                  entrySelector,
                  rangeShift:word;
            end;


    EndCount,StartCount,idDelta,idRangeOffset:array[1..100] of word;
    GlyphIDarray:array[1..10000] of word;

    i,j,k:integer;
    reserved:word;
    free_pos,segCount:integer;

    txt:text;

    array_len,typ:word;

    a,b:integer;
    where_cmap4:longint;


Procedure Do16(var arg);
Var w:word absolute arg;
Begin
     w:=((w shr 8) and 255) + (w and 255) shl 8;
End;

Procedure Do32(var arg);
Var w:longint absolute arg;
Begin
     w:=((w shr 24) and 255) + (((w shr 16) and 255) shl 8) +
        (((w shr 8) and 255) shl 16) + ((w and 255) shl 24);
End;

Procedure Mocni(max:integer; var a,b:integer);
var last,q,i:integer;
Begin
     q:=1;
     i:=0;
     repeat
           last:=q;
           q:=q*2;
           inc(i);
     until q>max;
     a:=last;
     b:=i-1;
End;


Begin
     assign(f1,'table01_.ttt');
     rewrite(f1,1);

     assign(txt,'table01_.txt');
     reset(txt);

     readln(txt,segCount);

     CmapDir.version:=0;  Do16(CmapDir.version);
     CmapDir.count:=1;    Do16(CmapDir.count);
     blockwrite(f1,CmapDir,4);

     CmapDirInfo.platformID:=3;  Do16(CmapDirInfo.platformID);
     CmapDirInfo.encodingID:=1;  Do16(CmapDirInfo.encodingID);
     CmapDirInfo.offset:=12;      Do32(CmapDirInfo.offset);
     blockwrite(f1,CmapDirInfo,8);


     where_cmap4:=filepos(f1);

     mocni(segcount,a,b);

     Cmap4.format:=4;   Do16(Cmap4.format);
     Cmap4.length:=0;   Do16(Cmap4.length);
     Cmap4.version:=0;   Do16(Cmap4.version);
     Cmap4.segCountX2:=2*segCount;   Do16(Cmap4.segCountX2);
     Cmap4.searchRange:=2*a;   Do16(Cmap4.searchRange);
     Cmap4.entryselector:=b;   Do16(Cmap4.entryselector);
     Cmap4.rangeshift:=2*segcount-2*a;   Do16(Cmap4.rangeshift);

     free_pos:=1;

     For i:=1 to segCount do
     Begin
          readln(txt,typ);
          If typ=0 then
          Begin
               readln(txt,startcount[i],endcount[i],iddelta[i]);
               idRangeOffset[i]:=0;
          End
          Else
          Begin
               readln(txt,startcount[i],endcount[i]);
               IdDelta[i]:=0;
               IdRangeOffset[i]:=(free_pos+(segCount-i))*2;

               For j:=startcount[i] to endcount[i] do
               Begin
                    read(txt,a);
                    glyphIDarray[free_pos]:=a;
                    inc(free_pos);
               End;
          End;
     End;

     Cmap4.length:=16+8*segcount+2*(free_pos-1);  Do16(Cmap4.length);
     reserved:=0;

     For i:=1 to segcount do Do16(startcount[i]);
     For i:=1 to segcount do Do16(endcount[i]);
     For i:=1 to segcount do Do16(iddelta[i]);
     For i:=1 to segcount do Do16(idRangeOffset[i]);
     For i:=1 to (free_pos-1) do Do16(glyphIDarray[i]);

     BlockWrite(f1,Cmap4,14);
     BlockWrite(f1,endcount,2*segcount);
     BlockWrite(f1,reserved,2);
     BlockWrite(f1,startcount,2*segcount);
     BlockWrite(f1,iddelta,2*segcount);
     BlockWrite(f1,idRangeOffset,2*segcount);
     BlockWrite(f1,glyphIDarray,2*(free_pos-1));

(*

     BlockRead(f1,CmapDir,4);

     Do16(CmapDir.version);
     Do16(CmapDir.count);

     For i:=1 to CmapDir.count do
     Begin
          BlockRead(f1,CmapDirInfo,8);
          Do16(CmapDirInfo.platformID);
          Do16(CmapDirInfo.encodingID);
          Do32(CmapDirInfo.Offset);

          If ((CmapDirInfo.platformID=3) and (CmapDirInfo.encodingID=1)) then
          Begin
               With CmapDirInfo do
               Begin
                    Seek(f1,offset);
                    BlockRead(f1,Cmap4,14);
                    Do16(Cmap4.format);
                    Do16(Cmap4.length);
                    Do16(Cmap4.version);
                    Do16(Cmap4.segCountX2);

                    If Cmap4.format<>4 then break;

                    segCount:=Cmap4.segCountX2 shr 1;


                    BlockRead(f1,endCount,2*segCount);
                    blockread(f1,reserved,2);
                    BlockRead(f1,startCount,2*segCount);
                    BlockRead(f1,idDelta,2*segCount);
                    BlockRead(f1,idRangeOffset,2*segCount);

                    array_len:=(Cmap4.length-16-8*segCount) div 2;

                    Blockread(f1,glyphIDarray,2*array_len);

                    For i:=1 to array_len do Do16(glyphIDarray[i]);
                    For i:=1 to segCount do Do16(startCount[i]);
                    For i:=1 to segCount do Do16(endCount[i]);
                    For i:=1 to segCount do Do16(idDelta[i]);
                    For i:=1 to segCount do Do16(idRangeOffset[i]);

                    writeln(txt,segCount,'   (pocet segmentov)'#13#10);

                    For i:=1 to segCount do
                    Begin
                         If idRangeOffset[i]=0 then
                         Begin
                              writeln(txt,'0   (idRangeOffset=0)');
                              writeln(txt,startcount[i],' ',endcount[i],' ',idDelta[i]);
                         End
                         Else
                         Begin
                              writeln(txt,'1   (idRangeOffset<>0)');
                              writeln(txt,startcount[i],' ',endcount[i]);
                              For j:=startcount[i] to endcount[i] do
                              Begin
                                   write(txt,glyphIDarray[(idRangeOffset[i] div 2)+j-startcount[i]-(segCount-i)],' ');
                              End;
                              writeln(txt,'');
                         End;
                         writeln(txt,'');
                    End;
                    
               End;

               break;
          End;
     End;
  *)
     close(txt);
     close(f1);
End.