Uses crt,tttypes,endian;

Type Thdmx = record
                   version:ushort;
                   count:short;
                   size:long;

                   item:record
                              ppem:byte;
                              max:byte;
                              widths:array[0..999] of byte;
                        end;
             end;

Const EM        = 1000;
      numGlyphs = 247;

var f,g:file;
    h:text;
    hdmx:Thdmx;
    i,j:integer;

    new_aw:array[0..999] of short;
    count:short;
    s:string;

    new_size:long;

Function x2i(s:string):integer;
Var hextab:string;
    i,n,v,a:integer;
Begin
     n:=1;
     v:=0;
     hextab:='0123456789ABCDEF';
     x2i:=-1;

     For i:=length(s) downto 1 do
     Begin
          a:=Pos(upcase(s[i]),hextab);
          If a=0 then exit;

          dec(a);
          v:=v+n*a;
          n:=16*n;
     End;

     x2i:=v;
End;

begin
     assign(f,'table05.ttt'); reset(f,1);
     assign(g,'table05_.ttt'); rewrite(g,1);
     assign(h,'table05.ttc'); reset(h);

     readln(h,count);
     For i:=0 to count-1 do
     Begin
          readln(h,s);
          new_aw[i]:=x2i(s);
     End;

     blockread(f,hdmx,8);
     Do16(hdmx.count);
     Do32(hdmx.size);

     new_size:=(((numglyphs+count+2)+3) div 4)*4;

     seek(g,8);

     For i:=1 to hdmx.count do
     Begin
          fillchar(hdmx.item.widths,1000,0);

          blockread(f,hdmx.item,hdmx.size);
          For j:=0 to count-1 do
          Begin
               hdmx.item.widths[numglyphs+j]:=trunc(new_aw[j]*hdmx.item.ppem/em);
          End;

          blockwrite(g,hdmx.item,new_size);
     End;

     seek(g,0);
     hdmx.size:=new_size;

     Do16(hdmx.count);
     Do32(hdmx.size);

     Blockwrite(g,hdmx,8);

     close(h); close(g); close(f);
end.